BeanApp.API/Controllers/BeansController.cs
using System.Threading.Tasks;
using BeanApp.Domain.Models;
using BeanApp.Services.Interfaces;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;

namespace BeanApp.API.Controllers
{
    [Authorize]
    public class BeansController : Controller
    {
        private readonly IBeanService _beanService;
        private readonly IBeanImageService _beanImageService;

        public BeansController(IBeanService beanService, IBeanImageService beanImageService)
        {
            _beanService = beanService;
            _beanImageService = beanImageService;
        }


        [HttpGet]
        public async Task<IActionResult> Index()
        {
            try
            {
                var beanList = await _beanService.GetAll();
                return View(beanList);
            }
            catch
            {
                return RedirectToAction("HttpStatusCodeHandler, Error");
            }
        }


        [HttpGet]
        [AllowAnonymous]
        public async Task<IActionResult> GetBeanOfTheDay()
        {
            try
            {
                var dailyBean = await _beanService.GetBeanOfTheDay();
                if (dailyBean == null)
                {
                    ViewBag.ErrorMessage = "The daily bean has not been posted at the moment, please try again later";
                    return View("NotFound");
                }

                return View(dailyBean);
            }
            catch
            {
                return RedirectToAction("HttpStatusCodeHandler, Error");
            }
        }

        [HttpGet]
        public async Task<IActionResult> Details(int id)
        {
            try
            {
                var bean = await _beanService.GetBeanById(id);
                if (bean == null)
                {
                    ViewBag.ErrorMessage = "Bean Not Found";
                    return View("NotFound");
                }

                return View(bean);
            }
            catch
            {
                return RedirectToAction("HttpStatusCodeHandler, Error");
            }
        }

        [HttpGet]
        public IActionResult Create()
        {
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([Bind("Id,BeanName,Aroma,Colour,CostPer100g,DateToBeShownOn,Image")] Bean bean, IFormFile file)
        {
            try
            {
                var dateCheck = await _beanService.DateCheck(bean);
                if (dateCheck != null)
                {
                    ViewBag.ErrorMessage = "Invalid date, A bean of the day already exists for this date.";
                    return View("InvalidDate");
                }

                if (file == null)
                {
                    ViewBag.ErrorMessage = "You haven't selected an image for this Bean!";
                    return View("NoImage");
                }

                if (ModelState.IsValid)
                {
                    var uploadedImage = await _beanImageService.UploadImage(file);
                    bean.Image = uploadedImage;

                    var createdBean = await _beanService.Create(bean);
                    return RedirectToAction(nameof(Index));
                }

                return View(bean);
            }
            catch
            {
                return RedirectToAction("HttpStatusCodeHandler, Error");
            }
        }

        [HttpGet]
        public async Task<IActionResult> Edit(int id)
        {
            try
            {
                var bean = await _beanService.GetBeanById(id);
                if (bean == null)
                {
                    ViewBag.ErrorMessage = "Bean Not Found";
                    return View("NotFound");
                }

                return View(bean);
            }
            catch
            {
                return RedirectToAction("HttpStatusCodeHandler, Error");
            }
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, [Bind("Id,BeanName,Aroma,Colour,CostPer100g,DateToBeShownOn")] Bean bean)
        {
            try
            {
                var dateCheck = await _beanService.DateCheck(bean);
                if (dateCheck != null)
                {
                    ViewBag.ErrorMessage = "Invalid date, A bean of the day already exists for this date.";
                    return View("InvalidDate");
                }

                if (id != bean.Id)
                {
                    ViewBag.ErrorMessage = "Bean Not Found";
                    return View("NotFound");
                }

                if (ModelState.IsValid)
                {
                    var updatedBean = await _beanService.Edit(id, bean);

                    return RedirectToAction(nameof(Index));
                }
                return View(bean);
            }
            catch
            {
                return RedirectToAction("HttpStatusCodeHandler, Error");
            } 
        }

        [HttpGet]
        public async Task<IActionResult> Delete(int id)
        {
            try
            {
                var bean = await _beanService.GetBeanById(id);
                if (bean == null)
                {
                    ViewBag.ErrorMessage = "Bean Not Found";
                    return View("NotFound");
                }

                return View(bean);
            }
            catch
            {
                return RedirectToAction("HttpStatusCodeHandler, Error");
            }
        }

        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            try
            {
                var bean = await _beanService.GetBeanById(id);
                await _beanService.Delete(bean);
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return RedirectToAction("HttpStatusCodeHandler, Error");
            }
        }
    }
}

BeanApp.API/Views/Beans/Create.cshtml
@model BeanApp.Domain.Models.Bean

@{
    ViewData["Title"] = "Create";
}

<h1>Create Bean</h1>

<p style="color:red">*<span style="color:black">Required</span></p> 

<hr />
@using (Html.BeginForm("Create",
 "Beans",
 FormMethod.Post,
 new { enctype = "multipart/form-data" }))
{
    <br>
    <div class="row">
        <div class="col-md-4">
            <form asp-action="Create">
                <div asp-validation-summary="ModelOnly" class="text-danger"></div>
                <div class="form-group">
                    <label asp-for="BeanName" class="control-label"></label>
                    <span style="color:red">*</span>
                    <input asp-for="BeanName" class="form-control" />
                    <span asp-validation-for="BeanName" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <label asp-for="Aroma" class="control-label"></label>
                    <input asp-for="Aroma" class="form-control" />
                    <span asp-validation-for="Aroma" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <label asp-for="Colour" class="control-label"></label>
                    <input asp-for="Colour" class="form-control" />
                    <span asp-validation-for="Colour" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <label asp-for="CostPer100g" class="control-label"></label>
                    <span style="color:red">*</span>
                    <input asp-for="CostPer100g" class="form-control" />
                    <span asp-validation-for="CostPer100g" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <label asp-for="DateToBeShownOn" class="control-label"></label>
                    <span style="color:red">*</span>
                    <input asp-for="DateToBeShownOn" class="form-control" />
                    <span asp-validation-for="DateToBeShownOn" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <label asp-for="Image" for="file">Upload Image:</label>
                    <span style="color:red">*</span>
                    <br>
                    <input type="file" name="file" id="file" />
                    <span asp-validation-for="Image" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <input type="submit" value="Create" class="btn btn-primary" />
                </div>
            </form>
        </div>
    </div>

    @ViewBag.Message
}


<div>
    <a asp-action="Index"><input type="submit" value="Back to List" class="btn btn-primary" /></a>
</div>

BeanApp.API/Views/Beans/Delete.cshtml
@model BeanApp.Domain.Models.Bean

@{
    ViewData["Title"] = "Delete";

}

<h1>Delete</h1>

<h3>Are you sure you want to delete this bean?</h3>
<div>
    <hr />
    <img src="@Url.Content(Model.Image.FileLocation)" alt="Bean Of The Day" style="height:200px;width:200px;" />
    <dl class="row">
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.BeanName)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.BeanName)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Aroma)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Aroma)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Colour)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Colour)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.CostPer100g)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.CostPer100g)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.DateToBeShownOn)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.DateToBeShownOn)
        </dd>
    </dl>

    <form asp-action="Delete">
        <input type="hidden" asp-for="Id" />
        <input type="submit" style="background-color: red; border-color: red;" value="Delete" class="btn btn-danger" />
    </form>
    <hr />
    <div>
        <a asp-action="Index"><input type="submit" value="Back to List" class="btn btn-primary" /></a>
    </div>
</div>

BeanApp.API/Views/Beans/Details.cshtml
@model BeanApp.Domain.Models.Bean

@{
    ViewData["Title"] = "Details";
}

<h1>Bean Details: @Html.DisplayFor(model => model.BeanName) </h1>

<div>

    <hr />
    <img src="@Url.Content(Model.Image.FileLocation)" alt="Bean Of The Day" style="height:200px;width:200px;" />
    <hr />
    <dl class="row">
        
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Aroma)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Aroma)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Colour)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Colour)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.CostPer100g)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.CostPer100g)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.DateToBeShownOn)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.DateToBeShownOn)
        </dd>
    </dl>
</div>
<div>
    <a asp-action="Edit" asp-route-id="@Model.Id"><input type="submit" style="background-color: goldenrod; border-color: goldenrod;" value="Edit" class="btn btn-primary" /></a> 
    <a asp-action="Index"><input type="submit" value="Back to List" class="btn btn-primary" /></a>
</div>

BeanApp.API/Views/Beans/Edit.cshtml
@model BeanApp.Domain.Models.Bean

@{
    ViewData["Title"] = "Edit";
}

<h1>Edit: @Html.DisplayFor(model => model.BeanName)</h1>

<hr />
@using (Html.BeginForm("Edit",
  "Beans",
  FormMethod.Post,
  new { enctype = "multipart/form-data" }))
{
    <div class="row">
        <div class="col-md-4">
            <form asp-action="Edit">
                <div asp-validation-summary="ModelOnly" class="text-danger"></div>
                <input type="hidden" asp-for="Id" />
                <div class="form-group">
                    <label asp-for="BeanName" class="control-label"></label>
                    <input asp-for="BeanName" class="form-control" />
                    <span asp-validation-for="BeanName" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <label asp-for="Aroma" class="control-label"></label>
                    <input asp-for="Aroma" class="form-control" />
                    <span asp-validation-for="Aroma" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <label asp-for="Colour" class="control-label"></label>
                    <input asp-for="Colour" class="form-control" />
                    <span asp-validation-for="Colour" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <label asp-for="CostPer100g" class="control-label"></label>
                    <input asp-for="CostPer100g" class="form-control" />
                    <span asp-validation-for="CostPer100g" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <label asp-for="DateToBeShownOn" class="control-label"></label>
                    <input asp-for="DateToBeShownOn" class="form-control" />
                    <span asp-validation-for="DateToBeShownOn" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <input type="submit" value="Save" class="btn btn-primary" />
                </div>
            </form>
        </div>
    </div>
    @ViewBag.Message
}

<div>
    <a asp-action="Index"><input type="submit" value="Back to List" class="btn btn-primary" /></a>
</div>

BeanApp.API/Views/Beans/GetBeanOfTheDay.cshtml
@model BeanApp.Domain.Models.Bean

@{
    ViewData["Title"] = "Bean of the day";
}

    <h1>Bean of the day: @Html.DisplayFor(model => model.BeanName)</h1>

<div>
    <h4> @Html.DisplayFor(model => model.DateToBeShownOn)</h4>
    <hr />
    <img src="@Url.Content(Model.Image.FileLocation)" alt="Bean Of The Day" style="height:200px;width:200px;" />
    <hr />
    <dl class="row">
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.BeanName)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.BeanName)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Aroma)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Aroma)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Colour)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Colour)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.CostPer100g)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.CostPer100g)
        </dd>
    </dl>
</div>
<div>
    <a asp-controller="Home" asp-action="Index"><input type="submit" value="Back to Home" class="btn btn-primary" /></a>
</div>

BeanApp.API/Views/Beans/Index.cshtml
@model IEnumerable<BeanApp.Domain.Models.Bean>

@{
    ViewData["Title"] = "Bean Seller Home";
}

<h1>Bean Seller Dashboard</h1>

<p>
    <a asp-action="Create"><input type="submit" value="Create New Bean" class="btn btn-primary" /></a>
</p>
<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.BeanName)
            </th>
            <!--
    <th>
        @Html.DisplayNameFor(model => model.Aroma)
    </th>
    <th>
        @Html.DisplayNameFor(model => model.Colour)
    </th>
    <th>
        @Html.DisplayNameFor(model => model.CostPer100g)
            </th>
            -->
            <th>
                @Html.DisplayNameFor(model => model.DateToBeShownOn)
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
    @foreach (var bean in Model) {
        <tr>
            <td>
                @Html.DisplayFor(modelItem => bean.BeanName)
            </td>
            <!--
    <td>
        @Html.DisplayFor(modelItem => bean.Aroma)
    </td>
    <td>
        @Html.DisplayFor(modelItem => bean.Colour)
    </td>
    <td>
        @Html.DisplayFor(modelItem => bean.CostPer100g)
    </td>
            -->
            <td>
                @Html.DisplayFor(modelItem => bean.DateToBeShownOn)
            </td>
            <td>
                <a asp-action="Details" asp-route-id="@bean.Id"><input type="submit" style="background-color: green; border-color: green;" value="View Details" class="btn btn-primary" /></a>
                <a asp-action="Edit" asp-route-id="@bean.Id"><input type="submit" style="background-color: goldenrod; border-color: goldenrod;" value="Edit" class="btn btn-primary" /></a>
                <a asp-action="Delete" asp-route-id="@bean.Id"><input type="submit" style="background-color: red; border-color: red;" value="Delete" class="btn btn-primary" /></a>
            </td>
        </tr>
    }
    </tbody>
</table>

BeanApp.API/Views/Beans/InvalidDate.cshtml
@{
    ViewBag.Title = "Invalid date";
}

<h1>@ViewBag.ErrorMessage</h1>

<input type="submit" value="Back" class="btn btn-primary" onclick="history.back()"/>

BeanApp.API/Views/Beans/NoImage.cshtml
@{
    ViewBag.Title = "No Image Selected";
}

<h1>@ViewBag.ErrorMessage</h1>

<input type="submit" value="Back" class="btn btn-primary" onclick="history.back()" />